Attribute VB_Name = "modFunc"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2018

Option Explicit

' **************** Sonstige Const ****************
Public Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const IID_QueryInterface As Long = &H0&
Private Const IID_IStream_Write As Long = &H10&
Private Const IID_IStream_Seek As Long = &H14&

' **************** sonstige Enums ****************
Public Enum Stream_Seek
    STREAM_SEEK_SET = &H0
    STREAM_SEEK_CUR = &H1
    STREAM_SEEK_END = &H2
End Enum

Public Enum STGM
    STGM_FAILIFTHERE = &H0&
    STGM_DIRECT = &H0&
    STGM_READ = &H0&
    STGM_WRITE = &H1&
    STGM_READWRITE = &H2&
    STGM_SHARE_EXCLUSIVE = &H10&
    STGM_SHARE_DENY_WRITE = &H20&
    STGM_SHARE_DENY_READ = &H30&
    STGM_SHARE_DENY_NONE = &H40&
    STGM_CREATE = &H1000&
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

Public Enum VARENUM
    VT_EMPTY = 0
    VT_NULL = 1
    VT_I2 = 2
    VT_I4 = 3
    VT_R4 = 4
    VT_R8 = 5
    VT_CY = 6
    VT_DATE = 7
    VT_BSTR = 8
    VT_DISPATCH = 9
    VT_ERROR = 10
    VT_BOOL = 11
    VT_VARIANT = 12
    VT_UNKNOWN = 13
    VT_DECIMAL = 14
    VT_I1 = 16
    VT_UI1 = 17
    VT_UI2 = 18
    VT_UI4 = 19
    VT_I8 = 20
    VT_UI8 = 21
    VT_INT = 22
    VT_UINT = 23
    VT_VOID = 24
    VT_HRESULT = 25
    VT_PTR = 26
    VT_SAFEARRAY = 27
    VT_CARRAY = 28
    VT_USERDEFINED = 29
    VT_LPSTR = 30
    VT_LPWSTR = 31
    VT_RECORD = 36
    VT_FILETIME = 64
    VT_BLOB = 65
    VT_STREAM = 66
    VT_STORAGE = 67
    VT_STREAMED_OBJECT = 68
    VT_STORED_OBJECT = 69
    VT_BLOB_OBJECT = 70
    VT_CF = 71
    VT_CLSID = 72
    VT_TYPEMASK = 4095
    VT_ILLEGALMASKED = 4095
    VT_VECTOR = 4096
    VT_ARRAY = 8192
    VT_BYREF = 16384
    VT_RESERVED = 32768
    VT_ILLEGAL = 65535
End Enum

' **************** sonstige Types ****************
Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Type PROPARRAY
    cElems As Long
    pElems As Long
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type PROPVARIANT_ARRAY
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As PROPARRAY
    Padding As Long
End Type

' **************** Shlwapi.dll ****************
Public Declare Function SHCreateStreamOnFileEx Lib "shlwapi.dll" ( _
                        ByVal pszFile As Long, _
                        ByVal grfMode As STGM, _
                        ByVal dwAttributes As Long, _
                        ByVal fCreate As Long, _
                        ByVal pstmTemplate As Long, _
                        ByRef ppstm As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pString As Long, _
                         ByRef pclsid As GUID) As Long

' **************** OleAut32.dll ****************
Private Declare Function DispCallFunc Lib "oleaut32.dll" ( _
                         ByVal ppv As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal rtTYP As VbVarType, _
                         ByVal paCNT As Long, _
                         ByRef paTypes As Any, _
                         ByRef paValues As Any, _
                         ByRef fuReturn As Variant) As Long

' **************** Kernel32.dll ****************
Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pDest As Any, _
                   ByRef pSource As Any, _
                   ByVal ByteLen As Long)

' ruft die Funktion Release eines Interfaces auf
Public Sub ReleaseInterface(ByRef pInterface As Long)

    Dim lRet As Long

    If pInterface <> 0 Then

        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, 0&, 0&, 0&, _
            lRet) = S_OK Then

            pInterface = 0&

        End If
    
    End If

End Sub

' ruft die Funktion QueryInterface eines Interfaces auf
Public Function QueryInterface(ByVal pInterface As Long, ByVal riid As String) As _
    Long

    Dim lRet As Long
    Dim pRet As Long
    Dim pObject As Long
    Dim ppObject As Long
    Dim tGUID As GUID
    Dim ptGUID As Long
    Dim ole_typ(1) As Integer
    Dim ole_ptr(1) As Long
    Dim ole_var(1) As Variant

    If pInterface <> 0 Then

        ppObject = VarPtr(pObject)
        tGUID = String2Guid(riid)
        ptGUID = VarPtr(tGUID)

        ole_typ(0) = VarType(ptGUID)
        ole_var(0) = ptGUID
        ole_ptr(0) = VarPtr(ole_var(0))

        ole_typ(1) = VarType(ppObject)
        ole_var(1) = ppObject
        ole_ptr(1) = VarPtr(ole_var(1))

        If DispCallFunc(pInterface, IID_QueryInterface, CC_STDCALL, vbLong, 2&, _
            ole_typ(0), ole_ptr(0), lRet) = S_OK Then

            pRet = pObject

        End If

    End If

    QueryInterface = pRet

End Function

Public Function IStream_Seek(ByVal pIStream As Long, ByVal dlibMove As Currency, _
    ByVal dwOrigin As Stream_Seek) As Currency

    Dim lRet As Long
    Dim cRet As Currency
    Dim libNewPosition As Currency
    Dim plibNewPosition As Long
    Dim ole_typ(2) As Integer
    Dim ole_ptr(2) As Long
    Dim ole_var(2) As Variant

    If pIStream <> 0 Then

        dlibMove = dlibMove / 10000
        plibNewPosition = VarPtr(libNewPosition)

        ole_typ(0) = VarType(dlibMove)
        ole_var(0) = dlibMove
        ole_ptr(0) = VarPtr(ole_var(0))

        ole_typ(1) = VarType(dwOrigin)
        ole_var(1) = dwOrigin
        ole_ptr(1) = VarPtr(ole_var(1))

        ole_typ(2) = VarType(plibNewPosition)
        ole_var(2) = plibNewPosition
        ole_ptr(2) = VarPtr(ole_var(2))

        If DispCallFunc(pIStream, IID_IStream_Seek, CC_STDCALL, vbLong, 3&, _
            ole_typ(0), ole_ptr(0), lRet) = S_OK Then

            cRet = libNewPosition * 10000

        End If

    End If

    IStream_Seek = cRet

End Function

Public Function IStream_Write(ByVal pIStream As Long, ByRef pv() As Byte, ByVal cb As Long) As Long

    Dim lRet As Long
    Dim ppv As Long
    Dim cbWritten As Long
    Dim pcbWritten As Long
    Dim ole_typ(2) As Integer
    Dim ole_ptr(2) As Long
    Dim ole_var(2) As Variant

    If pIStream <> 0 Then

        ppv = VarPtr(pv(0))
        pcbWritten = VarPtr(cbWritten)

        ole_typ(0) = VarType(ppv)
        ole_var(0) = ppv
        ole_ptr(0) = VarPtr(ole_var(0))

        ole_typ(1) = VarType(cb)
        ole_var(1) = cb
        ole_ptr(1) = VarPtr(ole_var(1))

        ole_typ(2) = VarType(pcbWritten)
        ole_var(2) = pcbWritten
        ole_ptr(2) = VarPtr(ole_var(2))

        If DispCallFunc(pIStream, IID_IStream_Write, CC_STDCALL, vbLong, 3&, _
            ole_typ(0), ole_ptr(0), lRet) = S_OK Then

            lRet = cbWritten

        End If

    End If
    
    IStream_Write = lRet
    
End Function

' konvertiert einen GUID-String nach Type GUID
Public Function String2Guid(ByVal sGUID As String) As GUID

    Dim tGUID As GUID
    Dim psGUID As Long

    psGUID = StrPtr(sGUID)

    Call CLSIDFromString(psGUID, tGUID)

    String2Guid = tGUID

End Function

' LPSTR-Pointer von einem String holen
Public Function String2LPSTR(ByVal sBSTR As String) As Long

    String2LPSTR = StrPtr(StrConv(sBSTR, vbFromUnicode))

End Function

' Prft ob eine Datei existiert
Public Function FileExists(FileName As String) As Boolean

    On Error Resume Next

    Dim ret As Long

    ret = Len(Dir$(FileName))

    If Err Or ret = 0 Then FileExists = False Else FileExists = True

End Function

